import { system, world} from "@minecraft/server";

world.beforeEvents.itemUseOn.subscribe(async (e) => {
  const itemid = e.itemStack.typeId
  if (!itemid.includes("ksb") || !itemid.includes("hoe")) return
  if (!e.block.permutation.matches("dirt") && !e.block.permutation.matches("grass_block") || e.source == undefined) return

  const location = e.block.location

  system.run(() => {
    e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} farmland`)
    e.source.runCommand("/playsound use.gravel @s")
    decreaseDurability(e.source)
  })
})

world.beforeEvents.itemUseOn.subscribe(async (e) => {
  const itemid = e.itemStack.typeId
  if (!itemid.includes("ksb") || !itemid.includes("shovel")) return
  if (!e.block.permutation.matches("dirt") && !e.block.permutation.matches("grass_block") && !e.block.permutation.matches("podzol") && !e.block.permutation.matches("mycelium") || e.source == undefined) return

  const location = e.block.location

  system.run(() => {
    e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} grass_path`)
    e.source.runCommand("/playsound use.gravel @s")
    decreaseDurability(e.source)
  })
})

world.beforeEvents.itemUseOn.subscribe(async (e) => {
  const itemid = e.itemStack.typeId

  if (!itemid.includes("ksb") || !itemid.includes("_axe")) return
  const block = e.block
  const location = e.block.location
  if (block.permutation.matches("minecraft:acacia_wood")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_acacia_wood`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:acacia_log")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_acacia_log`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:birch_wood")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_birch_wood`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:birch_log")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_birch_log`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:cherry_wood")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_cherry_wood`)
      e.source.runCommand("/playsound step.cherry_wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:cherry_log")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_cherry_log`)
      e.source.runCommand("/playsound step.cherry_wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:crimson_hyphae")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_crimson_hyphae`)
      e.source.runCommand("/playsound use.stem @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:crimson_stem")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_crimson_stem`)
      e.source.runCommand("/playsound use.stem @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:dark_oak_wood")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_dark_oak_wood`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:dark_oak_log")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_dark_oak_log`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:jungle_wood")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_jungle_wood`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:jungle_log")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_jungle_log`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:mangrove_wood")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_mangrove_wood`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:mangrove_log")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_mangrove_log`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:oak_wood")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_oak_wood`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:oak_log")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_oak_log`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:spruce_wood")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_spruce_wood`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:spruce_log")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_spruce_log`)
      e.source.runCommand("/playsound use.wood @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:warped_hyphae")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_warped_hyphae`)
      e.source.runCommand("/playsound use.stem @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:warped_stem")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_warped_stem`)
      e.source.runCommand("/playsound use.stem @s")
      decreaseDurability(e.source)
    })
  }
  else if (block.permutation.matches("minecraft:bamboo_block")) {
    system.run(() => {
      e.source.runCommand(`/setblock ${location.x} ${location.y} ${location.z} stripped_bamboo_block`)
      e.source.runCommand("/playsound step.bamboo_wood @s")
      decreaseDurability(e.source)
    })
  }
})


world.afterEvents.playerBreakBlock.subscribe(async e => {
  const item = e.itemStackAfterBreak

  if (!item.typeId.includes("ksb:")) return

  const durabilityComponent = item.getComponent('minecraft:durability');
  if (!durabilityComponent) return

  durabilityComponent.damage += 1
  durabilityComponent.damage = Math.min(durabilityComponent.damage + 1, durabilityComponent.maxDurability)
  const equippable = e.player.getComponent("minecraft:equippable")
  if (durabilityComponent.damage >= durabilityComponent.maxDurability) {
    player.runCommand("/playsound random.break @s")
    player.runCommand("/replaceitem entity @s slot.weapon.mainhand 0 minecraft:air")
    return
  }

  equippable.setEquipment("Mainhand", item)
})